/*****************************************************************************
 *
 *  MODULE NAME: CPICPORT.H
 *
 *  COPYRIGHTS:
 *             This module contains code made available by IBM
 *             Corporation on an AS IS basis.  Any one receiving the
 *             module is considered to be licensed under IBM copyrights
 *             to use the IBM-provided source code in any way he or she
 *             deems fit, including copying it, compiling it, modifying
 *             it, and redistributing it, with or without
 *             modifications.  No license under any IBM patents or
 *             patent applications is to be implied from this copyright
 *             license.
 *
 *             A user of the module should understand that IBM cannot
 *             provide technical support for the module and will not be
 *             responsible for any consequences of use of the program.
 *
 *             Any notices, including this one, are not to be removed
 *             from the module without the prior written consent of
 *             IBM.
 *
 *  AUTHOR:    Peter J. Schwaller
 *             VNET:     PJS at RALVM6           Tie Line: 444-4376
 *             Internet: pjs@ralvm6.vnet.ibm.com     (919) 254-4376
 *
 *  AVAILABILITY:
 *             These sample programs and source are also available on
 *             CompuServe through the APPC Information Exchange.  To get
 *             to the APPC forum just type 'GO APPC' from any CompuServe
 *             prompt.  The samples are available in the Sample Programs
 *             library section.  Just search on the keyword CPICPGMS to
 *             find all the samples in this series.
 *
 *             Updates for the sample programs and support for many more
 *             CPI-C platforms will also be made available on CompuServe.
 *
 *  RELATED FILES:
 *             Used by CPICPORT.C
 *
 *****************************************************************************/

#ifndef INCL_CPICPORT
#define INCL_CPICPORT


#if defined(VM) || defined(MVS)
#define  SHORT_IDENTIFIERS
#endif

#if defined(MVS) && 0
#define  TIME_NOT_SUPPORTED
#endif

#if (!(defined(OS2) || defined(FAPI)) || defined(OS2_20))
   #define  cdecl
   #define  FAR
   #define  far
#ifndef OS2_20
   #define  APIENTRY
#endif
#else
   #define  FAR   far
#endif

#if ! (defined(OS2_INCLUDED) || defined(CHAR))
    #define  CHAR  char
    #define  SHORT short
    #define  LONG  long
    typedef  unsigned char  UCHAR;
    typedef  unsigned short USHORT;
    typedef  unsigned long  ULONG;
    typedef  unsigned int   UINT;
    typedef  unsigned char  BYTE;
#endif

#ifndef TRUE
#define  TRUE  (1)
#endif

#ifndef FALSE
#define  FALSE (0)
#endif

#if defined(VM) || defined(MVS)
/* The C/370 compiler requires that identifier be unique in the 1st 8 chars. */
    #define  ascii_to_ebcdic_table        a2etab
    #define  ascii_to_ebcdic_field        a2efield
    #define  ebcdic_to_ascii_table        e2atab
    #define  ebcdic_to_ascii_field        e2afield
#endif


/* min and max macros */
#ifndef max
#define max(a,b)        (((a) > (b)) ? (a) : (b))
#endif

#ifndef min
#define min(a,b)        (((a) < (b)) ? (a) : (b))
#endif


void   ascii_to_ebcdic_field  (char * ascii_field,
                               USHORT field_size);
void   ebcdic_to_ascii_field  (char * ebcdic_field,
                               USHORT field_size);

#if defined(VM) || defined(MVS) || defined(OS400)
#define convert_to_ascii(buffer, len)  ebcdic_to_ascii_field(buffer,len)
#define convert_from_ascii(buffer, len) ascii_to_ebcdic_field(buffer,len)
#else
#define convert_to_ascii(buffer, len)
#define convert_from_ascii(buffer, len)
#endif

extern char ascii_to_ebcdic_table[];
extern char ebcdic_to_ascii_table[];

#if defined(OS2) || defined(FAPI) || defined(DOS) || defined(OS2_20)
#ifndef SWAP2
/* Macro SWAP2 swaps the bytes in a two-byte integer         */
#define SWAP2(s)           (unsigned short)(((s)<<8)|(((s)&0xFF00)>>8))
#endif

#ifndef SWAP4
/* Macro SWAP4 swaps the bytes in a four-byte integer        */
#define SWAP4(l)           (unsigned long)(((l)<<24)|(((l)&0xFF000000)>>24)\
                           |(((l)&0xFF00)<<8)|(((l)&0xFF0000)>>8))
#endif

#define  convert_long_to_network(x)        SWAP4(x)
#define  convert_short_to_network(x)       SWAP2(x)
#define  convert_long_from_network(x)      SWAP4(x)
#define  convert_short_from_network(x)     SWAP2(x)
#else
#define  convert_long_to_network(x)        x
#define  convert_short_to_network(x)       x
#define  convert_long_from_network(x)      x
#define  convert_short_from_network(x)     x
#endif

char far *  alloc_cpic_buffer(   USHORT size);
void        show_info(          char * * text);
USHORT      get_machine_mode(   void);
void        set_echo(int mode);
int         get_passwd(char * passwd, int max_length);

#ifdef OS400
int strupr (char * string);
#endif

#endif
